Subject: RE: Debugging of embedded target applications

From: "Siders, Keith" <[email-masked]>
Date: Wed, 8 May 2002 08:05:43 -0500

Thanks for the lively discussion and input. It's now clear to me that I'll
be tracking (not tracing) the kernel with the h/w debugger through its kgdb
shell. We're still working on some drivers, so control over the kernel is a
must. I'll have to set up the server to autoload when a connection on a
particular port is attempted from another gdb shell, and shut down on
disconnection.

Keith

-> -----Original Message-----
-> From: Daniel Jacobowitz [mailto:[email-masked]]
-> Sent: Tuesday, May 07, 2002 9:33 PM
-> To: Geoffrey Espin
-> Cc: Siders, Keith; Linux-Mips (E-mail)
-> Subject: Re: Debugging of embedded target applications
-> 
-> 
-> On Tue, May 07, 2002 at 07:25:23PM -0700, Geoffrey Espin wrote:
-> > On Tue, May 07, 2002 at 09:43:14PM -0400, Daniel Jacobowitz wrote:
-> > > > Does work it for kernel type debugging over *Ethernet*?
-> > > > I see some docs saying "TCP/IP" connection... but does that
-> > > > mean a special kind of network driver?  Or a gdbstub/agent
-> > > > outside the kernel in a special monitor?
-> > > What do you mean by kernel type debugging?  It's not a 
-> kernel stub.  It
-> > > can debug user programs over TCP/IP or a serial line.
-> > 
-> > In traditional embedded RTOS land, "system-level debugging".
-> > In the olden days one had to have BDM/JTAG hardware assist
-> > to step thru truly arbitary bits of code, like interrupt handlers,
-> > scheduler.
-> > 
-> > The original question was about using using a hardware debugger.
-> > Clearly using gdb/gdbserver is for apps only, AFAIK.  Does one
-> > bother with a h/w debugger for apps?  Using kgdb with some kind
-> 
-> Actually, yes, you can.  I believe at least the Abatron BDI can do
-> this.  Could be wrong, though.
-> 
-> > of remote debug-agent would be a "system level debugger", a s/w
-> > solution to a traditional hardware only debug aid.  At this time
-> > kind of pointless, as its painful to setup and JTAG debuggers
-> > are so cheap (for mainline CPUs).
-> 
-> Depends on your platform.
-> 
-> -- 
-> Daniel Jacobowitz                           Carnegie Mellon 
-> University
-> MontaVista Software                         Debian GNU/Linux 
-> Developer
->